<?php

namespace AppBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;
use AppBundle\Entity\User;

class DefaultController extends Controller
{
    /**
     * @Route("/", name="homepage")
     */
    public function indexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $latlngs = $em->getRepository('AppBundle:LatLng')->findAll();
        // replace this example code with whatever you need
        //$user = new User();

        $form = $this->get('fos_user.registration.form.factory')->createForm();
        //$form = $form->createForm();
        //$form->setData($user);

        $form->handleRequest($request);
        //$form = $this->createForm('AppBundle\Form\RegistrationType', $user);

        
        $imagenes_slide = $em->getRepository('AppBundle:EvidenciaImagen')->findImagenSlideshow();

         
        return $this->render('default/index.html.twig', [
            'base_dir' => realpath($this->getParameter('kernel.project_dir')).DIRECTORY_SEPARATOR,
            'form' => $form->createView(),
            'imagenes_slide' => $imagenes_slide,
            'upload_dir' => $this->getParameter('upload_directory'),
            'latlngs' => $latlngs
        ]);

    }

    public function loginRedirectAction(Request $request)
    {

        if (!$this->get('security.authorization_checker')->isGranted('IS_AUTHENTICATED_FULLY'))
        {
            return $this->redirectToRoute('fos_user_security_login');
            // throw $this->createAccessDeniedException();
        }

        if($this->get('security.authorization_checker')->isGranted('ROLE_SUPER_ADMIN'))
        {
            return $this->redirectToRoute('user_index');
        }
        else if($this->get('security.authorization_checker')->isGranted('ROLE_EMPRESA'))
        {
            $user = $this->getUser();

            if (!$user->isPerfilCompleto()) {
                return $this->redirectToRoute('perfil_edit');
            }
            return $this->redirectToRoute('donar_index',array('estado' => 'activas'));
        }
        else if($this->get('security.authorization_checker')->isGranted('ROLE_GRUPO_COM'))
        {
            $user = $this->getUser();
            if (!$user->isPerfilCompleto()) {
                return $this->redirectToRoute('perfil_edit');
            }
            return $this->redirectToRoute('postular_publicacion_index');
        }
        else if($this->get('security.authorization_checker')->isGranted('ROLE_MUNICIPIO'))
        {
            return $this->redirectToRoute('user_index');
        }
        else
        {
            return $this->redirectToRoute('fos_user_security_login');
        }
    }
    
        
    public function busquedaAction(Request $request) {
        $paginator  = $this->get('knp_paginator');
        $em = $this->getDoctrine()->getManager();

        $texto = $request->request->get('texto');
        
        $query = $em->getRepository('AppBundle:Publicacion')->busqueda($texto);
        
        $pagination = $paginator->paginate($query, $request->query->getInt('page', 1), 15);
        
        
        return $this->render('default/publicaciones.html.twig', array(
            'publicacions' => $pagination,
            'title' => "Donaciones encontradas con \"" . $texto . "\""
        ));
    }
}
