<?php

namespace AppBundle\Entity;

/**
 * DatosUsuarioGrupoComunitario
 */
class DatosUsuarioGrupoComunitario extends DatosUsuario
{
    
    /**
     * @var string
     */
    private $objetivo;

    /**
     * @var string
     */
    private $lugarDesarrollo;

    /**
     * @var string
     */
    private $poblacionBeneficiaria;

    private $postulaciones;

    /**
     * @var string
     */
    
    private $personeriaJuridica;
    
    /**
     * @var string
     */
    private $telefono;
    
    /**
     * @var string
     */
    
    private $paginaWeb;
    
    /**
     * @var string
     */
    private $redSocial;

    /**
     * @var string
     */
    private $cuit;

    /**
     * @var bool
     */
    private $personeria;

    /**
     * Set objetivo
     *
     * @param string $objetivo
     *
     * @return DatosUsuarioGrupoComunitario
     */
    public function setObjetivo($objetivo)
    {
        $this->objetivo = $objetivo;

        return $this;
    }

    /**
     * Get objetivo
     *
     * @return string
     */
    public function getObjetivo()
    {
        return $this->objetivo;
    }

    /**
     * Set lugarDesarrollo
     *
     * @param string $lugarDesarrollo
     *
     * @return DatosUsuarioGrupoComunitario
     */
    public function setLugarDesarrollo($lugarDesarrollo)
    {
        $this->lugarDesarrollo = $lugarDesarrollo;

        return $this;
    }

    /**
     * Get lugarDesarrollo
     *
     * @return string
     */
    public function getLugarDesarrollo()
    {
        return $this->lugarDesarrollo;
    }

    /**
     * Set poblacionBeneficiaria
     *
     * @param string $poblacionBeneficiaria
     *
     * @return DatosUsuarioGrupoComunitario
     */
    public function setPoblacionBeneficiaria($poblacionBeneficiaria)
    {
        $this->poblacionBeneficiaria = $poblacionBeneficiaria;

        return $this;
    }

    /**
     * Get poblacionBeneficiaria
     *
     * @return string
     */
    public function getPoblacionBeneficiaria()
    {
        return $this->poblacionBeneficiaria;
    }
    
    
    public function getDescripcion()
    {
        return "Organización";
    }
    
    public function esGrupoComunitario() {
        return true;
    }

    public function __construct()
    {
        $this->postulaciones = new \Doctrine\Common\Collections\ArrayCollection();
    }
    public function __toString() {
        return $this->getDescripcion();
    }

    /**
     * Add postulacion
     *
     * @param \AppBundle\Entity\Postulacion $postulacion
     *
     * @return DatosUsuarioGrupoComunitario
     */
    public function addPostulacion(\AppBundle\Entity\Postulacion $postulacion)
    {
        $this->postulaciones[] = $postulacion;

        return $this;
    }

    /**
     * Remove postulacion.
     *
     * @param \AppBundle\Entity\Postulacion $postulacion
     *
     * @return boolean TRUE if this collection contained the specified element, FALSE otherwise.
     */
    public function removePostulacion(\AppBundle\Entity\Postulacion $postulacion)
    {
        return $this->postulaciones->removeElement($postulacion);
    }

    public function getPostulaciones() {
        return $this->postulaciones;
    }
    
    
    public function getPersoneriaJuridica() {
        return $this->personeriaJuridica;
    }
    public function setPersoneriaJuridica($personeriaJuridica) {
        $this->personeriaJuridica = $personeriaJuridica;
        return $this;
    }
    
    public function getTelefono() {
        return $this->telefono;
    }
    
    public function setTelefono($telefono) {
        $this->telefono = $telefono;
        return $this;
    }
    
    public function getPaginaWeb() {
        return $this->paginaWeb;
    }
    
    public function setPaginaWeb($paginaWeb) {
        $this->paginaWeb = $paginaWeb;
        return $this;
    }
    
    public function getRedSocial() {
        return $this->redSocial;
    }
    
    public function setRedSocial($redSocial) {
        $this->redSocial = $redSocial;
        return $this;
    }

    /**
     * Get the value of cuit
     *
     * @return  string
     */ 
    public function getCuit()
    {
        return $this->cuit;
    }

    /**
     * Set the value of cuit
     *
     * @param  string  $cuit
     *
     * @return  self
     */ 
    public function setCuit(string $cuit)
    {
        $this->cuit = $cuit;

        return $this;
    }

    /**
     * Get the value of personeria
     *
     * @return  bool
     */ 
    public function getPersoneria()
    {
        return $this->personeria;
    }

    /**
     * Set the value of personeria
     *
     * @param  bool  $personeria
     *
     * @return  self
     */ 
    public function setPersoneria(bool $personeria)
    {
        $this->personeria = $personeria;

        return $this;
    }
}
