<?php

namespace AppBundle\Entity;

use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Validator\Mapping\ClassMetadata;
/**
 * Evidencia
 */
class Evidencia
{
    /**
     * @var int
     */
    private $id;

    /**
     * @var string|null
     */
    private $url;

    /**
     * @var \Doctrine\Common\Collections\Collection
     */
    private $imagenes;

    /**
     * @var \AppBundle\Entity\DatosUsuarioGrupoComunitario
     */
    
    private $grupo;


    public function getGrupo(){
        return $this->grupo; 
     }
     
    /**
      * Set grupo
      *
      * @param \AppBundle\Entity\DatosUsuarioGrupoComunitario $grupo
      *
      * @return Evidencia
      */
     
     public function setGrupo($grupo) {
         $this->grupo = $grupo;
         return $this;
     }

     /**
     * @var int
     */
    private $puntuacion_grupo;
    
    /**
     * @var int
     */
    private $puntuacion_empresa;
    
    private $postulacion;
    /**
     * Get id.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }


    /**
     * @var \DateTime
     */
    private $fecha;

    /**
     * @var \DateTime
     */
    private $fechaEntrega;


    /**
     * Set url.
     *
     * @param string|null $url
     *
     * @return Evidencia
     */
    public function setUrl($url = null)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * Get url.
     *
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
 

    /**
     * Get the value of fecha
     *
     * @return  \DateTime
     */ 
    public function getFecha()
    {
        return $this->fecha;
    }

    /**
     * Set the value of fecha
     *
     * @param  \DateTime  $fecha
     *
     * @return  self
     */ 
    public function setFecha(\DateTime $fecha)
    {
        $this->fecha = $fecha;

        return $this;
    }

    /**
     * Get the value of fechaEntrega
     *
     * @return  \DateTime
     */ 
    public function getFechaEntrega()
    {
        return $this->fechaEntrega;
    }

    /**
     * Set the value of fechaEntrega
     *
     * @param  \DateTime  $fechaEntrega
     *
     * @return  self
     */ 
    public function setFechaEntrega(\DateTime $fechaEntrega)
    {
        $this->fechaEntrega = $fechaEntrega;

        return $this;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->imagenes = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Get the value of imagenes
     *
     * @return  \Doctrine\Common\Collections\Collection
     */ 
    public function getImagenes()
    {
        return $this->imagenes;
    }

    /**
     * Add EvidenciaImagen
     *
     * @param \AppBundle\Entity\EvidenciaImagen $imagen
     *
     * @return Evidencia
     */
    public function addImage(\AppBundle\Entity\EvidenciaImagen $imagen)
    {
        // Bidirectional Ownership
        $imagen->setEvidencia($this);
        
        $this->imagenes[] = $imagen;
        
        return $this;
    }
    
    /**
     * Remove EvidenciaImagen
     *
     * @param \AppBundle\Entity\EvidenciaImagen $imagen
     */
    public function removeImage(\AppBundle\Entity\EvidenciaImagen $imagen)
    {
        $this->imagenes->removeElement($imagen);
    }
    
    
    public function getPuntuacionGrupo() {
        return $this->puntuacion_grupo;
    }
    
    public function setPuntuacionGrupo($puntuacion) {
        $this->puntuacion_grupo = $puntuacion;
        return $this;
    }
    public function getPuntuacionEmpresa() {
        return $this->puntuacion_empresa;
    }
    
    public function setPuntuacionEmpresa($puntuacion) {
        $this->puntuacion_empresa = $puntuacion;
        return $this;
    }
    public function getPostulacion() {
        return $this->postulacion;
    }
    
    public function setPostulacion($postulacion) {
        $this->postulacion = $postulacion;
        return $this;
    }
    
     public static function loadValidatorMetadata(ClassMetadata $metadata)
    {
        //$metadata->addPropertyConstraint('puntuacion_empresa', new Assert\Range(['min' => 1, 'max' => 5]));
        //$metadata->addPropertyConstraint('puntuacion_grupo', new Assert\Range(['min' => 1, 'max' => 5]));
    }
}
