<?php

// Change the namespace according to your project.
namespace AppBundle\Entity;



use HWI\Bundle\OAuthBundle\OAuth\Response\UserResponseInterface;
use HWI\Bundle\OAuthBundle\Security\Core\User\FOSUBUserProvider as BaseFOSUBProvider;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Security\Core\Exception\UsernameNotFoundException;
use Symfony\Component\Security\Core\Exception\UnsupportedUserException;



class FOSUBUserProvider extends BaseFOSUBProvider
{
    /**
     * {@inheritDoc}
     */
    public function connect(UserInterface $user, UserResponseInterface $response)
    {
        // get property from provider configuration by provider name
        // , it will return `facebook_id` in that case (see service definition below)
        $property = $this->getProperty($response);
        $username = $response->getUsername(); // get the unique user identifier

        //we "disconnect" previously connected users
        $existingUser = $this->userManager->findUserBy(array($property => $username));
        if (null !== $existingUser) {
            // set current user id and token to null for disconnect
            // ...

            $this->userManager->updateUser($existingUser);
        }
        // we connect current user, set current user id and token
        // ...
        $this->userManager->updateUser($user);
    }

    /**
     * {@inheritdoc}
     */
    public function loadUserByOAuthUserResponse(UserResponseInterface $response)
    {
        $userEmail = $response->getEmail();
        $user = $this->userManager->findUserByEmail($userEmail);

        $serviceName = $response->getResourceOwner()->getName();
        $getter = 'get' . ucfirst($serviceName) . 'Id';

        // if null just create new user and set it properties
        if (null === $user) {
            throw new UsernameNotFoundException(sprintf('Email "%s" no esta registrado.', $userEmail));
            $user = new User();
            return $user;
        }
        else if($user->$getter() === '-1') {
            throw new UnsupportedUserException(sprintf('"%s" no esta habilitado, debe ingresar con facebook desde el perfil de usuario.', ucfirst($serviceName)));
            $user = new User();
            return $user;
        }


        // else update access token of existing user
        $setter = 'set' . ucfirst($serviceName) . 'AccessToken';
        $user->$setter($response->getAccessToken());//update access token
        
        //update id
        $setter = 'set' . ucfirst($serviceName) . 'Id';
        $user->$setter($response->getData()['id']);//update id

        return $user;
    }
}