<?php

namespace AppBundle\Entity;

/**
 * Postulacion
 */
class Postulacion
{
    /**
     * @var int
     */
    private $id;

    /**
     * @var string|null
     */
    private $resultado;

    private $grupo;

    private $publicacion;

    private $evidencia;


    /**
     * @var \DateTime
     */
    private $fecha;

    /**
     * @var bool
     */
    private $enabled;

    /**
     * Get id.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set resultado.
     *
     * @param string|null $resultado
     *
     * @return Postulacion
     */
    public function setResultado($resultado = null)
    {
        $this->resultado = $resultado;

        return $this;
    }

    public function setResultadoAceptada() {
        return $this->setResultado('A');
    }
    
    public function setResultadoSolicitada() {
        return $this->setResultado('S');
    }

    public function setResultadoRendida() {
        return $this->setResultado('R');
    }

    public function estaAceptada() {
        return $this->resultado == 'A';
    }
    
    public function estaRendida() {
        return $this->resultado == 'R';
    }
    /**
     * Get resultado.
     *
     * @return string|null
     */
    public function getResultado()
    {
        return $this->resultado;
    }

    /**
     * Set publicacion.
     *
     * @param \AppBundle\Entity\Publicacion|null $publicacion
     *
     * @return Postulacion
     */
    public function setPublicacion(\AppBundle\Entity\Publicacion $publicacion = null)
    {
        $this->publicacion = $publicacion;

        return $this;
    }

    /**
     * Get publicacion.
     *
     * @return \AppBundle\Entity\Publicacion|null
     */
    public function getPublicacion()
    {
        return $this->publicacion;
    }

    /**
     * Set grupo.
     *
     * @param \AppBundle\Entity\DatosUsuarioGrupoComunitario|null $grupo
     *
     * @return Postulacion
     */
    public function setGrupo(\AppBundle\Entity\DatosUsuarioGrupoComunitario $grupo = null)
    {
        $this->grupo = $grupo;

        return $this;
    }

    /**
     * Get grupo.
     *
     * @return \AppBundle\Entity\DatosUsuarioGrupoComunitario|null
     */
    public function getGrupo()
    {
        return $this->grupo;
    }

    public function setEnabled($boolean)
    {
        $this->enabled = (bool) $boolean;

        return $this;
    }

    public function isEnabled()
    {
        return $this->enabled;
    }

    /**
     * Set fecha
     *
     * @param \DateTime $fecha
     *
     * @return Postulacion
     */
    public function setFecha($fecha)
    {
        $this->fecha = $fecha;

        return $this;
    }

    /**
     * Get fecha
     *
     * @return \DateTime
     */
    public function getFecha()
    {
        return $this->fecha;
    }


    /**
     * Get the value of evidencia
     */ 
    public function getEvidencia()
    {
        return $this->evidencia;
    }

    /**
     * Set the value of evidencia
     *
     * @return  self
     */ 
    public function setEvidencia($evidencia)
    {
        $this->evidencia = $evidencia;

        return $this;
    }
}
