<?php

namespace AppBundle\Entity;

use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Validator\Mapping\ClassMetadata;
/**
 * Publicacion
 */
class Publicacion
{
    /**
     * @var int
     */
    private $id;

    /**
     * @var string
     */
    private $titulo;

    /**
     * @var string
     */
    private $descripcion;

    /**
     * @var \DateTime
     */
    private $fecha_alta;
    /**
     * @var \DateTime
     */
    private $fecha_vencimiento;

    /**
     * @var \DateTime
     */
    private $fecha_publicacion;

    /**
     * @var \DateTime
     */
    private $fecha_fin_publicacion;
       
    /**
     * @var \AppBundle\Entity\Ods
     */
    private $ods;
    
    /**
     * @var \AppBundle\Entity\Actividad
     */
    
    private $categoria;
    
    /**
     * @var \Doctrine\Common\Collections\Collection
     */
    private $imagenes;

    /**
     * @var \Doctrine\Common\Collections\Collection
     */
    private $candidatos;
    

    /**
     * @var string
     */
    private $estado;
    
    /**
     * @var \AppBundle\Entity\DatosUsuarioEmpresa
     */
    
    private $empresa;
    
    /**
     * @var \AppBundle\Entity\DatosUsuarioGrupoComunitario
     */
    
    private $grupo_comunitario;


    /**
     * @var bool
     */
    private $entregaEmpresa;

    /**
     * @var bool
     */
    private $entregaDomicilio;

    /**
     * @var string
     */
    private $entregaDomicilioInfo;

    /**
     * @var bool
     */
    private $entregaOtra;

    /**
     * @var string
     */
    private $entregaOtraInfo;

    private $listaOds;

    
    /**
     * Get id
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set titulo
     *
     * @param string $titulo
     *
     * @return Publicacion
     */
    public function setTitulo($titulo)
    {
        $this->titulo = $titulo;

        return $this;
    }

    /**
     * Get titulo
     *
     * @return string
     */
    public function getTitulo()
    {
        return $this->titulo;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     *
     * @return Publicacion
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set fecha
     *
     * @param \DateTime $fecha
     *
     * @return Publicacion
     */
    public function setFechaAlta($fecha_alta)
    {
        $this->fecha_alta = $fecha_alta;

        return $this;
    }

    /**
     * Get fecha
     *
     * @return \DateTime
     */
    public function getFechaAlta()
    {
        return $this->fecha_alta;
    }

    /**
     * Set fechaPublicacion
     *
     * @param \DateTime $fechaPublicacion
     *
     * @return Publicacion
     */
    public function setFechaPublicacion($fecha_publicacion)
    {
        $this->fecha_publicacion = $fecha_publicacion;

        return $this;
    }

    /**
     * Get fechaPublicacion
     *
     * @return \DateTime
     */
    public function getFechaPublicacion()
    {
        return $this->fecha_publicacion;
    }

    /**
     * Set fechaFinPublicacion
     *
     * @param \DateTime $fechaFinPublicacion
     *
     * @return Publicacion
     */
    public function setFechaFinPublicacion($fecha_fin_publicacion)
    {
        $this->fecha_fin_publicacion = $fecha_fin_publicacion;

        return $this;
    }

    /**
     * Get fechaFinPublicacion
     *
     * @return \DateTime
     */
    public function getFechaFinPublicacion()
    {
        return $this->fecha_fin_publicacion;
    }

    /**
     * Set ods
     *
     * @param \AppBundle\Entity\Ods $ods
     *
     * @return Publicacion
     */
    public function setOds($ods)
    {
        $this->ods = $ods;

        return $this;
    }

    /**
     * Get ods
     *
     * @return \AppBundle\Entity\Ods $ods
     */
    public function getOds()
    {
        return $this->ods;
    }
    /**
     * Set ods
     *
     * @param \AppBundle\Entity\Categoria $categoria
     *
     * @return Publicacion
     */
    public function setCategoria($categoria)
    {
        $this->categoria = $categoria;

        return $this;
    }

    /**
     * Get ods
     *
     * @return \AppBundle\Entity\Categoria $categoria
     */
    public function getCategoria()
    {
        return $this->categoria;
    }
    
    /**
     * Set titulo
     *
     * @param string $estado
     *
     * @return Publicacion
     */
    public function setEstado($estado)
    {
        $this->estado = $estado;

        return $this;
    }

    public function setEstadoAbierta() {
        return $this->setEstado('A');
    }
    
    public function setEstadoPendiente() {
        return $this->setEstado('P');
    }

    public function setEstadoEntregada() {
        return $this->setEstado('E');
    }
    
    /**
     * Get estado
     *
     * @return string
     */
    public function getEstado()
    {
        return $this->estado;
    }
    
    public function getEmpresa(){
       return $this->empresa; 
    }
    
     /**
     * Set empresa
     *
     * @param \AppBundle\Entity\DatosUsuarioEmpresa $empresa
     *
     * @return Publicacion
     */
    
    public function setEmpresa($empresa) {
        $this->empresa = $empresa;
        return $this;
    }
    
    public function getGrupoComunitario(){
       return $this->grupo_comunitario; 
    }
    
     /**
     * Set empresa
     *
     * @param \AppBundle\Entity\DatosUsuarioGrupoComunitario $grupo_comunitario
     *
     * @return Publicacion
     */
    
    public function setGrupoComunitario($grupo_comunitario) {
        $this->grupo_comunitario = $grupo_comunitario;
        return $this;
    }
    
    /**
     * @var \DateTime
     */
    function getFechaVencimiento() {
        return $this->fecha_vencimiento;
    }

    function setFechaVencimiento(\DateTime $fecha_vencimiento = null) {
        $this->fecha_vencimiento = $fecha_vencimiento;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->imagenes = new \Doctrine\Common\Collections\ArrayCollection();
        $this->candidatos = new \Doctrine\Common\Collections\ArrayCollection();
        $this->listaOds = new \Doctrine\Common\Collections\ArrayCollection();
    }

    public function getCandidatos() {
        return $this->candidatos;
    }

    public function getCandidatosHabilitados() {
        $resultado = new \Doctrine\Common\Collections\ArrayCollection();
        foreach ($this->candidatos as $candidato) {
            if ($candidato->isEnabled()) {
                $resultado->add($candidato);
            }
        }
        return $resultado;
    }

    /**
     * Get the value of imagenes
     *
     * @return  \Doctrine\Common\Collections\Collection
     */ 
    public function getImagenes()
    {
        return $this->imagenes;
    }

    /**
     * Add PublicacionImagen
     *
     * @param \AppBundle\Entity\PublicacionImagen $imagen
     *
     * @return Publicacion
     */
    public function addImage(\AppBundle\Entity\PublicacionImagen $imagen)
    {
        // Bidirectional Ownership
        $imagen->setPublicacion($this);
        
        $this->imagenes[] = $imagen;
        
        return $this;
    }
    
    /**
     * Remove PublicacionImagen
     *
     * @param \AppBundle\Entity\PublicacionImagen $imagen
     */
    public function removeImage(\AppBundle\Entity\PublicacionImagen $imagen)
    {
        $this->imagenes->removeElement($imagen);
    }


    /**
     * Add candidato.
     *
     * @param \AppBundle\Entity\Postulacion $candidato
     *
     * @return Publicacion
     */
    public function addCandidato(\AppBundle\Entity\Postulacion $candidato)
    {
        $this->candidatos[] = $candidato;

        return $this;
    }

    /**
     * Remove candidato.
     *
     * @param \AppBundle\Entity\Postulacion $candidato
     *
     * @return bool TRUE if this collection contained the specified element, FALSE otherwise.
     */
    public function removeCandidato(\AppBundle\Entity\Postulacion $candidato)
    {
        return $this->candidatos->removeElement($candidato);
    }
    
    public static function loadValidatorMetadata(ClassMetadata $metadata)
    {
        $metadata->addPropertyConstraint('titulo', new Assert\NotBlank());
        $metadata->addPropertyConstraint('categoria', new Assert\NotBlank());
        $metadata->addPropertyConstraint('fecha_publicacion', new Assert\GreaterThanOrEqual(['value' => 'today', 'message' => 'La fecha de publicacion debe ser mayor a hoy']));
        $metadata->addPropertyConstraint('fecha_fin_publicacion', new Assert\Expression([
            'expression' => "this.getFechaFinPublicacion() >= this.getFechaPublicacion()",
            'message' => "La fecha de finalización debe ser mayor a la fecha de publicación"
            ]));
    }


    /**
     * Get the value of entregaEmpresa
     *
     * @return  bool
     */ 
    public function getEntregaEmpresa()
    {
        return $this->entregaEmpresa;
    }

    /**
     * Set the value of entregaEmpresa
     *
     * @param  bool  $entregaEmpresa
     *
     * @return  self
     */ 
    public function setEntregaEmpresa(bool $entregaEmpresa)
    {
        $this->entregaEmpresa = $entregaEmpresa;

        return $this;
    }

    /**
     * Get the value of entregaDomicilio
     *
     * @return  bool
     */ 
    public function getEntregaDomicilio()
    {
        return $this->entregaDomicilio;
    }

    /**
     * Set the value of entregaDomicilio
     *
     * @param  bool  $entregaDomicilio
     *
     * @return  self
     */ 
    public function setEntregaDomicilio(bool $entregaDomicilio)
    {
        $this->entregaDomicilio = $entregaDomicilio;

        return $this;
    }

    /**
     * Get the value of entregaDomicilioInfo
     *
     * @return  string
     */ 
    public function getEntregaDomicilioInfo()
    {
        return $this->entregaDomicilioInfo;
    }

    /**
     * Set the value of entregaDomicilioInfo
     *
     * @param  string  $entregaDomicilioInfo
     *
     * @return  self
     */ 
    public function setEntregaDomicilioInfo(string $entregaDomicilioInfo)
    {
        $this->entregaDomicilioInfo = $entregaDomicilioInfo;

        return $this;
    }

    /**
     * Get the value of entregaOtra
     *
     * @return  bool
     */ 
    public function getEntregaOtra()
    {
        return $this->entregaOtra;
    }

    /**
     * Set the value of entregaOtra
     *
     * @param  bool  $entregaOtra
     *
     * @return  self
     */ 
    public function setEntregaOtra(bool $entregaOtra)
    {
        $this->entregaOtra = $entregaOtra;

        return $this;
    }

    /**
     * Get the value of entregaOtraInfo
     *
     * @return  string
     */ 
    public function getEntregaOtraInfo()
    {
        return $this->entregaOtraInfo;
    }

    /**
     * Set the value of entregaOtraInfo
     *
     * @param  string  $entregaOtraInfo
     *
     * @return  self
     */ 
    public function setEntregaOtraInfo(string $entregaOtraInfo)
    {
        $this->entregaOtraInfo = $entregaOtraInfo;

        return $this;
    }
    
    public function estaPendiente() {
        return ($this->estado == 'P');
    }
    public function estaEntregado() {
        return ($this->estado == 'E');
    }
    public function estaAbierta() {
        return ($this->estado == 'A');
    }

    /**
     * Get the value of listaOds
     */ 
    public function getListaOds()
    {
        return $this->listaOds;
    }

    /**
     * Set the value of listaOds
     *
     * @return  self
     */ 
    public function setListaOds($listaOds)
    {
        $this->listaOds = $listaOds;

        return $this;
    }
    /**
     * @var \AppBundle\Entity\Solicitud
     */
    private $solicitud;


    /**
     * Set solicitud.
     *
     * @param \AppBundle\Entity\Solicitud|null $solicitud
     *
     * @return Publicacion
     */
    public function setSolicitud(\AppBundle\Entity\Solicitud $solicitud = null)
    {
        $this->solicitud = $solicitud;

        return $this;
    }

    /**
     * Get solicitud.
     *
     * @return \AppBundle\Entity\Solicitud|null
     */
    public function getSolicitud()
    {
        return $this->solicitud;
    }

   
}
