<?php

namespace AppBundle\Entity;

/**
 * Solicitud
 */
class Solicitud
{
    /**
     * @var int
     */
    private $id;

    /**
     * @var string
     */
    private $titulo;

    /**
     * @var string
     */
    private $descripcion;

    /**
     * @var \DateTime|null
     */
    private $fechaVencimiento;

    /**
     * @var \AppBundle\Entity\DatosUsuarioGrupoComunitario
     */
    private $grupo;

    /**
     * @var \AppBundle\Entity\Categoria
     */
    private $categoria;
    
    private $cerrada;


    /**
     * Get id.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set titulo.
     *
     * @param string $titulo
     *
     * @return Solicitud
     */
    public function setTitulo($titulo)
    {
        $this->titulo = $titulo;

        return $this;
    }

    /**
     * Get titulo.
     *
     * @return string
     */
    public function getTitulo()
    {
        return $this->titulo;
    }

    /**
     * Set descripcion.
     *
     * @param string $descripcion
     *
     * @return Solicitud
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion.
     *
     * @return string
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set fechaVencimiento.
     *
     * @param \DateTime|null $fechaVencimiento
     *
     * @return Solicitud
     */
    public function setFechaVencimiento($fechaVencimiento = null)
    {
        $this->fechaVencimiento = $fechaVencimiento;

        return $this;
    }

    /**
     * Get fechaVencimiento.
     *
     * @return \DateTime|null
     */
    public function getFechaVencimiento()
    {
        return $this->fechaVencimiento;
    }

    /**
     * Set grupo.
     *
     * @param \AppBundle\Entity\DatosUsuarioGrupoComunitario|null $grupo
     *
     * @return Solicitud
     */
    public function setGrupo(\AppBundle\Entity\DatosUsuarioGrupoComunitario $grupo = null)
    {
        $this->grupo = $grupo;

        return $this;
    }

    /**
     * Get grupo.
     *
     * @return \AppBundle\Entity\DatosUsuarioGrupoComunitario|null
     */
    public function getGrupo()
    {
        return $this->grupo;
    }

    /**
     * Set categoria.
     *
     * @param \AppBundle\Entity\Categoria|null $categoria
     *
     * @return Solicitud
     */
    public function setCategoria(\AppBundle\Entity\Categoria $categoria = null)
    {
        $this->categoria = $categoria;

        return $this;
    }

    /**
     * Get categoria.
     *
     * @return \AppBundle\Entity\Categoria|null
     */
    public function getCategoria()
    {
        return $this->categoria;
    }
    
    public function getCerrada() {
        return $this->cerrada;
    }
    
    public function setCerrada($boolean) {
        $this->cerrada = $boolean;
    }
    
    private $publicacion;
    
    public function getPublicacion(){
        return $this->publicacion;
    }
}
