<?php
// src/AppBundle/Entity/User.php

namespace AppBundle\Entity;

use FOS\UserBundle\Model\User as BaseUser;
use Doctrine\ORM\Mapping as ORM;

use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Validator\Mapping\ClassMetadata;

class User extends BaseUser
{
    /**
     * @Assert\Valid
     */

    protected $datos_usuario; 
    protected $id;

    protected $fechaCambio;
    protected $idUsuarioCambio;

    protected $perfilCompleto;

    protected $habilitado;

    protected $facebook_id;
    protected $facebook_access_token;

    protected $googleplus_id;
    protected $googleplus_access_token;
       
    public function __construct()
    {
        parent::__construct();
      
    }

    
    /**
     * Get DatosUsuario
     *
     * @return \AppBundle\Entity\DatosUsuario
     */
    public function getDatosUsuario()
    {
        return $this->datos_usuario;
    }
    
    
    
    
    
    /**
     * Set datosUsuario
     *
     * @param \AppBundle\Entity\DatosUsuario $datosUsuario
     *
     * @return User
     */
    public function setDatosUsuario(\AppBundle\Entity\DatosUsuario $datosUsuario = null)
    {
        $this->datos_usuario = $datosUsuario;

        return $this;
    }
    
    
    public function setEmail($email)
    {
    $email = is_null($email) ? '' : $email;
    parent::setEmail($email);
    $this->setUsername($email);

    return $this;
    }

     public static function loadValidatorMetadata(ClassMetadata $metadata)
    {
        $metadata->addPropertyConstraint('datos_usuario', new Assert\Valid());
    }

    /**
     * Get the value of fechaCambio
     * @return \DateTime|null 
     */ 
    public function getFechaCambio()
    {
        return $this->fechaCambio;
    }

    /**
     * Set the value of fechaCambio (actual)
     *
     * @return  self
     */ 
    public function setFechaCambio($fechaCambio)
    {
        $this->fechaCambio = $fechaCambio;

        return $this;
    }

    /**
     * Get the value of idUsuarioCambio
     */ 
    public function getIdUsuarioCambio()
    {
        return $this->idUsuarioCambio;
    }

    /**
     * Set the value of idUsuarioCambio
     *
     * @return  self
     */ 
    public function setIdUsuarioCambio($idUsuarioCambio)
    {
        $this->idUsuarioCambio = $idUsuarioCambio;

        return $this;
    }


    public function isPerfilCompleto(){
        return ($this->perfilCompleto == true);
    }

    public function setPerfilCompleto($perfilCompleto = true)
    {
        $this->perfilCompleto = $perfilCompleto;

        return $this;
    }

    /**
     * Get the value of habilitado
     */ 
    public function isHabilitado()
    {
        return ($this->habilitado == true);
    }

    /**
     * Get the value of habilitado
     */ 
    public function getHabilitado()
    {
        return $this->habilitado;
    }

    /**
     * Set the value of habilitado
     *
     * @return  self
     */ 
    public function setHabilitado($habilitado = true)
    {
        $this->habilitado = $habilitado;

        return $this;
    }

    /**
     * Get the value of facebook_id
     */ 
    public function getFacebookId()
    {
        return $this->facebook_id;
    }

    /**
     * Set the value of facebook_id
     *
     * @return  self
     */ 
    public function setFacebookId($facebook_id)
    {
        $this->facebook_id = $facebook_id;

        return $this;
    }

    /**
     * Get the value of facebook_access_token
     */ 
    public function getFacebookAccessToken()
    {
        return $this->facebook_access_token;
    }

    /**
     * Set the value of facebook_access_token
     *
     * @return  self
     */ 
    public function setFacebookAccessToken($facebook_access_token)
    {
        $this->facebook_access_token = $facebook_access_token;

        return $this;
    }

    public function setGoogleplusId($googlePlusId) {
        $this->googleplus_id = $googlePlusId;
    
        return $this;
    }
    
    public function getGoogleplusId() {
        return $this->googleplus_id;
    }
    
    public function setGoogleplusAccessToken($googleplusAccessToken) {
        $this->googleplus_access_token = $googleplusAccessToken;
    
        return $this;
    }
    
    public function getGoogleplusAccessToken() {
        return $this->googleplus_access_token;
    }


}
