<?php

namespace AppBundle\EventListener;

use Doctrine\ORM\EntityManager;
use FOS\UserBundle\Event\UserEvent;
use FOS\UserBundle\Event\FormEvent;
use FOS\UserBundle\FOSUserEvents;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\Routing\Generator\UrlGeneratorInterface;
use Doctrine\ORM\EntityManagerInterface;


class RegistrationEventListener implements EventSubscriberInterface
{
private $router;
private $em;

public function __construct(UrlGeneratorInterface $router,EntityManagerInterface $em) {
    $this->router = $router;
    $this->em = $em;
}

/**
 * {@inheritdoc}
 */
public static function getSubscribedEvents()
{
    return array(
        FOSUserEvents::REGISTRATION_INITIALIZE => 'onRegistrationInit',
        FOSUserEvents::REGISTRATION_SUCCESS => 'onRegistrationSuccess',
        FOSUserEvents::REGISTRATION_FAILURE => 'onRegistrationFailure',
        FOSUserEvents::REGISTRATION_CONFIRMED => 'onRegistrationCompleted',
    );

    
}

public function onRegistrationInit(UserEvent $userEvent)
{
       
}

public function onRegistrationFailure(FormEvent $formEvent)
{
    //$url = $this->router->generate('homepage');
    //$formEvent->setResponse((new RedirectResponse($url."#error")));
}

public function onRegistrationSuccess(FormEvent $userEvent) {
    if ($userEvent->getForm()) {
      $usuario = $userEvent->getForm()->getData();
      
      //$usuario->setEnabled(false); dejar comentado hasta despues del demo
      if ($usuario->getDatosUsuario()->esGrupoComunitario()) {
          $usuario->setRoles(array("ROLE_GRUPO_COM"));
      }
      else {
          $usuario->setRoles(array("ROLE_EMPRESA"));
      }
    /*
      $usuario->setHabilitado(false);
      $this->em->persist($usuario);
      $this->em->flush();
    */
    }

}

public function onRegistrationCompleted(UserEvent $event) {
    $user = $event->getUser();
    $user->setEnabled(false);
    $this->em->persist($user);
    $this->em->flush();
}

}