<?php

namespace AppBundle\Form;

use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;


class DatosUsuarioGrupoComunitarioType extends DatosUsuarioType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        parent::buildForm($builder, $options);
        $builder->add('objetivo')->add('actividad')->add('lugar_desarrollo')->add('poblacion_beneficiaria')
                //->add('personeria_juridica', null, array('label' => 'Personería jurídica'))
                ->add('personeria', ChoiceType::class, [
                    'choices' => ['No' => false, 'Si' => true],
                    'label' => 'Personería jurídica'
                ])
                ->add('cuit', null, ['empty_data' => '','required'=> false, 'attr' => ["placeholder" => "XX-XXXXXXXX-X"]])
                ->add('telefono', null, array('required' => false,'label' => 'Teléfono'))
                ->add('pagina_web', null, array('label' => 'Página web'))
                ->add('red_social');
    }
    
    
    /**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\DatosUsuarioGrupoComunitario'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_datosusuario';
    }


}
