<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use AppBundle\Entity\Municipio;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

class DatosUsuarioType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
        ->add('nombre',null ,['attr' => ["placeholder" => "Nombre de Empresa/Organización *"]] )
        ->add('nombre_responsable', null, ['attr' => ["placeholder" => "Nombre del responsable *"]])
        ->add('municipio', EntityType::class, [
            'class' => Municipio::class,
            'placeholder' => 'Nombre del municipio',
        ])
        ->add('direccion',null, ['attr' => ["placeholder" => "Dirección *"]])
        ->add('cp',null, ['label' => 'Código Postal','attr' => ["placeholder" => "Código Postal *"]])
        ->add('latlngs', CollectionType::class, [
                'by_reference' => false,
                'label' => false,
                'entry_type' => LatLngsType::class,
                'entry_options' => ['label' => false],
                'allow_add' => true,
                'allow_delete' => true,
        ]);

    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\DatosUsuarioAnonimo'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_datosusuario';
    }


}
