<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Validator\Constraints as Assert;


class EvidenciaShowType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder->add('url', null, [
            'required'   => false,
            'disabled'   => true,           
        ])
        ->add('fechaEntrega', DateType::class, [
            'widget' => 'single_text',
            'label' => 'Fecha de Entrega',
            'disabled'   => true,           
            ])
        ->add('puntuacion_empresa', HiddenType::class, 
             array('mapped' => true,
             'constraints' => array(
                              new Assert\Range(['min' => 1, 'max' => 5])
                              
                          )));
    }
    
    /**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\Evidencia'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_evidencia';
    }


}
