<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use AppBundle\Entity\Ods;





class PublicacionType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder->add('titulo',null,['label' => 'Título', 'required'=> !$options["solicitud"], 'disabled'=> $options["solicitud"], 'attr' => ['placeholder' => 'Título de la donación']])
                ->add('descripcion',null,[ 'required'=> !$options["solicitud"], 'disabled'=> $options["solicitud"], 'attr' => ['placeholder' => 'Descripción de la donación']])
                /*->add('ods',null,['label'=>false,
                    'expanded'=> true,
                    'multiple'=> false,
                    'required'=> true,
                    ])*/
                ->add('listaOds', EntityType::class, [
                        'class' => Ods::class,
                        'multiple' => true,
                        'expanded' => true,
                        'required'=> true,
                    ])    
                ->add('categoria', null, [
                     'required'=> !$options["solicitud"], 'disabled'=> $options["solicitud"],
                    'expanded'=> true,
                    'multiple'=> false,
                    'required'=> true,
                    ])
        
        ->add('fechaPublicacion', DateType::class, [
                'required'=> !$options["solicitud"], 'disabled'=> $options["solicitud"],
                'widget' => 'single_text',
                'label' => 'Fecha de publicación'
                ])
        ->add('fechaFinPublicacion', DateType::class, [
                'required'=> !$options["solicitud"], 'disabled'=> $options["solicitud"],
                'widget' => 'single_text',
                'label' => 'Fecha de fin de publicación'
                ])
        ->add('fechaVencimiento', DateType::class, [
                'widget' => 'single_text',
                'label' => ' ',
                'required'=> false])
        ;

        $builder
            ->add('entregaEmpresa', CheckboxType::class, array(
                'label'    => 'Retiro en sede de la empresa',
                'required' => false,))
            ->add('entregaDomicilio', CheckboxType::class, array(
            'label'    => 'Envío a domicilio',
            'required' => false,))
            ->add('entregaDomicilioInfo',TextType::class, [
                'empty_data' => '',
                'required' => true,
            ],['attr' => ['placeholder' => 'Horario para entrega a domicilio']])
            ->add('entregaOtra', CheckboxType::class, array(
                'label'    => 'Otra',
                'required' => false,))
            ->add('entregaOtraInfo',TextType::class, [
                'empty_data' => '',
                'required' => true,
            ],['attr' => ['placeholder' => 'Detalle forma de entrega ']])
        ;
        
    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\Publicacion',
            'solicitud' => false,
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_publicacion';
    }


}
