<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;

class SolicitudType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder->add('titulo',null,['label' => 'Título', 'attr' => ['placeholder' => 'Título de la donación']])
                ->add('descripcion',null,['attr' => ['placeholder' => 'Descripción de la donación']])
                ->add('fechaVencimiento', DateType::class, [
                'widget' => 'single_text',
                'label' => 'Fecha límite'
                ])
                 ->add('categoria', null, [
                    'expanded'=> true,
                    'multiple'=> false,
                    'required'=> true,
                    ]);
    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\Solicitud'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_solicitud';
    }


}
