<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use AppBundle\Entity\DatosUsuario;
use AppBundle\Form\DatosUsuarioType;

use AppBundle\Form\DatosUsuarioGrupoComunitarioType;
use AppBundle\Form\DatosUsuarioEmpresaType;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Form\FormEvent;


class UserBackType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        
        $builder->add('rol', ChoiceType::class, [
            'choices' => ['Empresa' => "empresa",'Organización' => "grupo_com",'Municipio' => "municipio"],
            'mapped' => false,
            'label' => "Tipo de Usuario"
        ])
    ->remove('username');
    //if ($options["type"] == null)
    $builder->add('datos_usuario', DatosUsuarioRegistroType::class, [
'label' => ' ',
]);
    /*else if ($options["type"] == "empresa")
            $builder->add('datos_usuario', DatosUsuarioEmpresaRegistroType::class);
    else if ($options["type"] == "grupo_com") {
            $builder->add('datos_usuario', DatosUsuarioGrupoComunitarioRegistroType::class);
    }*/
    $builder->addEventListener(FormEvents::PRE_SUBMIT, array($this, 'onPreSetData'));
    $builder->addEventListener(FormEvents::POST_SUBMIT, array($this, 'onPostSubmit'));

        
        $builder->add('plainPassword', RepeatedType::class, array(
                'required' => false,
                'type' => PasswordType::class,
                'options' => array(
                    'translation_domain' => 'FOSUserBundle',
                    'attr' => array(
                        'autocomplete' => 'new-password',
                    ),
                ),
                'first_options' => array('label' => 'form.password'),
                'second_options' => array('label' => 'form.password_confirmation'),
                'invalid_message' => 'fos_user.password.mismatch',
            ));
                
        if ($options["type"] == null) {
                $builder->add('datos_usuario', DatosUsuarioMunicipioType::class);
               // $builder->remove('rol');
        }
        else {
            
            $builder->remove('rol');
            if ($options["type"] == "empresa") {
                        $builder->add('datos_usuario', DatosUsuarioEmpresaType::class);
            }
            else if ($options["type"] == "grupo_com") {
                        $builder->add('datos_usuario', DatosUsuarioGrupoComunitarioType::class);
            }
            else if ($options["type"] == "municipio") {
                        $builder->add('datos_usuario', DatosUsuarioMunicipioType::class);
            }

        }
    }

    public function onPreSetData(FormEvent $event)
    {
        $form = $event->getForm();
        $submittedData = $event->getData();
        //$user = $event->getData();
        if (isset($submittedData["rol"]) && $submittedData["rol"] == "empresa") {
            $form->add('datos_usuario', DatosUsuarioEmpresaRegistroType::class, [
            'label' => ' ',
        ]);
        }
        else if (isset($submittedData["rol"]) && $submittedData["rol"] == "grupo_com") {
            $form->add('datos_usuario', DatosUsuarioGrupoComunitarioRegistroType::class, [
            'label' => ' ',
        ]);
        }
        
    }

    public function onPostSubmit(FormEvent $event)
    {
        //No debería hacer falta esto
        $user = $event->getData();
        $datos_usuario = $user->getDatosUsuario();
        $datos_usuario->setUsuario($user);

    }
 
    
    public function getParent()
    {
        return 'FOS\UserBundle\Form\Type\RegistrationFormType';

        // Or for Symfony < 2.8
        // return 'fos_user_registration';
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_userback';
    }
    
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'type' => null,
        ));
    }
    
}
