<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use AppBundle\Entity\DatosUsuario;
use AppBundle\Form\DatosUsuarioType;
class UserType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        
        parent::buildForm($builder, $options);
        
        
        $builder->add('plainPassword', RepeatedType::class, array(
                'required' => false,
                'type' => PasswordType::class,
                'options' => array(
                    'translation_domain' => 'FOSUserBundle',
                    'attr' => array(
                        'autocomplete' => 'new-password',
                    ),
                ),
                'first_options' => array('label' => 'form.password'),
                'second_options' => array('label' => 'form.password_confirmation'),
                'invalid_message' => 'fos_user.password.mismatch',
            ));
                
        if ($options["type"] == null) {
                $builder->add('datos_usuario', DatosUsuarioMunicipioType::class);
               // $builder->remove('rol');
        }
        else {
            
            $builder->remove('rol');
            if ($options["type"] == "empresa") {
                        $builder->add('datos_usuario', DatosUsuarioEmpresaType::class);
            }
            else if ($options["type"] == "grupo_com") {
                        $builder->add('datos_usuario', DatosUsuarioGrupoComunitarioType::class);
            }

        }
    }
    
    public function getParent()
    {
        return 'AppBundle\Form\RegistrationType';

        // Or for Symfony < 2.8
        // return 'fos_user_registration';
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_user';
    }
    
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'type' => null,
        ));
    }
    
}
