<?php

namespace AppBundle\Repository;
use Symfony\Component\Validator\Constraints\Date;
/**
 * PublicacionRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PublicacionRepository extends \Doctrine\ORM\EntityRepository
{

public function findVigentes($estado = null, $solo_query = true, $empresa = null, $municipio = null)
{
    return $this->findPublicaciones($estado, $solo_query, $empresa, $municipio, true);
}


public function findPublicaciones($estado = null, $solo_query = true, $empresa = null, $municipio = null, $solo_vigentes) {
    $query = $this->createQueryBuilder('p');
    $order = 'asc';
    if ($municipio) {
                $query = $query->join('AppBundle:DatosUsuarioEmpresa', 'emp', 'WITH', 'emp = p.empresa')
                ->where('emp.municipio = :municipio')->setParameter('municipio', $municipio);
    }
    if ($solo_vigentes) {
                $query = $query->andWhere('p.fecha_fin_publicacion >= :today')
                ->setParameter('today', new \DateTime());
    }
    if ($estado) {
              $query->andWhere('p.estado = :estado') 
              ->setParameter('estado', $estado);
    }
    if ($empresa) {
                $query->andWhere('p.empresa = :empresa') 
                ->setParameter('empresa', $empresa);
    } 
    $query =  $query->addOrderBy('p.estado','asc');
    if (!$solo_vigentes) { $order = 'desc'; }
        $query =  $query->addOrderBy('p.fecha_vencimiento',$order);
        $query =  $query->addOrderBy('p.fecha_fin_publicacion',$order)
        ->getQuery();
    if (!$solo_query) {
        return $query->getResult();
    }
    return $query;
}

public function countVigentes($estado = null, $empresa = null)
{
    $query = $this->createQueryBuilder('p')
                ->select('count(p.id)')
                ->where('p.fecha_fin_publicacion >= :today')
                ->setParameter('today', new \DateTime());
    if ($estado) {
              $query->andWhere('p.estado = :estado') 
              ->setParameter('estado', $estado);
    }
    if ($empresa) {
                $query->andWhere('p.empresa = :empresa') 
                ->setParameter('empresa', $empresa);
    }
    $query =  $query->getQuery();
    return $query->getSingleScalarResult();
}

public function countPublicacionesOds($municipio = null) {
    $query = $this->createQueryBuilder('p')->select('count(p.id)');
    $query = $query->join('p.ods', 'o');
  
    if ($municipio) {
        $query = $query->join('AppBundle:DatosUsuarioEmpresa', 'emp', 'WITH', 'emp = p.empresa')
        ->where('emp.municipio = :municipio')->setParameter('municipio', $municipio);
    }
    
    return $query->getQuery()->getSingleScalarResult();
}

public function busqueda($texto) {
            $texto = strtolower($texto);
            $query = $this->createQueryBuilder('p')
            ->join('AppBundle:DatosUsuarioEmpresa', 'emp', 'WITH', 'emp = p.empresa')
            ->join('AppBundle:Municipio', 'mun', 'WITH', 'mun = emp.municipio')
            ->leftJoin('AppBundle:Postulacion', 'pos', 'WITH','pos.publicacion = p')
            ->leftJoin('AppBundle:DatosUsuarioGrupoComunitario', 'gc', 'WITH', 'gc = pos.grupo');
            $query = $query->andWhere($query->expr()->orX(
                $query->expr()->like($query->expr()->lower('p.titulo'), ':texto'),
                $query->expr()->like($query->expr()->lower('emp.nombre'), ':texto'),
                $query->expr()->like($query->expr()->lower('mun.nombre'), ':texto'),
                $query->expr()->like($query->expr()->lower('gc.nombre'), ':texto')
            ));
            $query->setParameter('texto', '%' . $texto . '%')
                    ->orderBy('p.fecha_fin_publicacion','desc');
            return $query->getQuery();
}

}
